/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package es.rickyepoderi.snmpjmxagent;

import org.snmp4j.agent.MOAccess;
import org.snmp4j.smi.OID;
import org.snmp4j.smi.Variable;

/**
 * <p>Class that maps a JMX MBean and a SNMP entry (OID and type).</p>
 * 
 * @author ricky
 */
public class ScalarAttributeDescription {
    
    //
    // SCALAR ARRAY
    //
    
    /**
     * The OID for the JMX attribute in SNMP.
     */
    private OID oid = null;
    
    /**
     * The attribute name in JMX.
     */
    private String attributeName = null;
    
    /**
     * The attribute type in JMX, the class.
     */
    private Class attributeType = null;
    
    //
    // MOFactory part
    //
    
    /**
     * The access of this OID in SNMP.
     */
    private MOAccess access = null;
    
    /**
     * The type of variable to use in SNMP for this JMX attribute.
     */
    private Variable variable = null;
        
    //
    // CONSTRUCTORS
    //

    /**
     * Empty constructor.
     */
    public ScalarAttributeDescription() {
        // empty desc
    }

    /**
     * COnstructor via properties.
     * 
     * @param oid The OID for SNMP.
     * @param attributeName The attribute name in JMX.
     * @param attributeType The attribute class in JMX.
     * @param access The SNMP access type.
     * @param variable The variable (type) in SNMP.
     */
    public ScalarAttributeDescription(OID oid, String attributeName,
            Class attributeType, MOAccess access, Variable variable) {
        this.oid = oid;
        this.attributeName = attributeName;
        this.attributeType = attributeType;
        this.access = access;
        this.variable = variable;
    }
    
    //
    // GETTERS & SETTERS
    //
    
    /**
     * Getter for OID.
     * @return The OID
     */
    public OID getOid() {
        return oid;
    }

    /**
     * Setter for OID.
     * @param oid new OID
     */
    public void setOid(OID oid) {
        this.oid = oid;
    }

    /**
     * Setter for the attribute name.
     * @return The attribute name
     */
    public String getAttributeName() {
        return attributeName;
    }

    /**
     * Setter of the attribute name.
     * @param attributeName The new attribute name
     */
    public void setAttributeName(String attributeName) {
        this.attributeName = attributeName;
    }

    /**
     * Getter for the attribute type.
     * @return The attribute type 
     */
    public Class getAttributeType() {
        return attributeType;
    }

    /**
     * Setter for the attribute type.
     * @param attributeType The attribute type
     */
    public void setAttributeType(Class attributeType) {
        this.attributeType = attributeType;
    }

    /**
     * Getter for the access.
     * @return The access
     */
    public MOAccess getAccess() {
        return access;
    }

    /**
     * Setter for the access.
     * @param access The new access
     */
    public void setAccess(MOAccess access) {
        this.access = access;
    }

    /**
     * Getter for the variable.
     * @return The variable
     */
    public Variable getVariable() {
        return variable;
    }

    /**
     * Setter for the variable
     * @param variable The new variable
     */
    public void setVariable(Variable variable) {
        this.variable = variable;
    }

}
